node('master') {
    def docker_img
    
    stage('Checkout') {
        echo "Checking out Source code"
        checkout scm
    }
    stage('Build Docker Image') {
        echo "Starting Docker Image build"
        docker_img = docker.build("vshivaku/ubuntu:16.04")
    }    
    stage('Build') {
        docker_img.inside {
            echo "Starting Build inside Docker Container"
            sh 'make build'
        }
    }
    parallel Test1: {
      stage('Test1') {
        docker_img.inside {
            echo "Starting Test1 inside Docker Container"
            sh 'make test1'
        }
      }
    }, Test2: {
      stage('Test2') {
        docker_img.inside {
            echo "Starting Test2 inside Docker Container"
            sh 'make test2'
        }
      }
    }, Test3: {
      stage('Test3') {
        docker_img.inside {
            echo "Starting Test3 inside Docker Container"
            sh 'make test3'
        }
      }
    },
    failFast: true
    stage('Publish') {
        echo "Publishing Tag ${BUILD_TAG}"
    }
    stage('Archive Artifacts') {
        archiveArtifacts allowEmptyArchive: true, artifacts: 'add, Dockerfile, Jenkinsfile'
    }     
}